<template>
  <div class="card-body p-3">
    <div class="row justify-content-center g-0">
      <div class="col">
        <h3 class="strong mb-0">
          <span v-if="scenario"
            >{{ scenario.title }} {{ scenario.version }}</span
          >
        </h3>
      </div>
      <div class="col col-auto mr-1">
        <OutputsCardControls :previous-job="previousJob" :next-job="nextJob">
        </OutputsCardControls>
      </div>
    </div>
    <div class="mt-2 outputs-file-search-form outputs-file-search-form-3 w-50">
      <ExploreSearchBox
        :first="firstParameterIndex"
        :last="filteredParameterCount"
        :total="totalParameterCount"
        placeholder="Search in parameters..."
        item-type="parameters"
        @search="setSearchValue"
      />
    </div>
    <div class="mt-3">
      <div class="table-responsive table-outputs table-outputs-3 mt-3">
        <table class="table card-table table-center datatable small">
          <thead>
            <tr>
              <th class="w-50">Parameter</th>
              <th class="w-50">Value</th>
            </tr>
          </thead>
        </table>
        <b-nav class="nav-vertical">
          <li
            v-for="p in filteredParameterTree"
            :key="p.index"
            class="nav-item"
          >
            <ParametersPanelSet
              v-if="p.type === 'group'"
              :set="p"
              panel-input-component="OutputsCardParamValueTable"
              :config="activeJob.config"
            />
            <OutputsCardParamValueTable
              v-else
              :parameter="p"
              :config="activeJob.config"
            />
          </li>
        </b-nav>
      </div>
    </div>
  </div>
</template>
<script>
import { mapGetters } from 'vuex';
import searchFilterMixin from '~/mixins/search-filter.js';
export default {
  mixins: [searchFilterMixin],
  props: {
    job: {
      type: Object,
      default: () => {},
    },
    previousJob: {
      type: Object,
      default: () => {},
    },
    nextJob: {
      type: Object,
      default: () => {},
    },
  },
  data() {
    return {
      valueToSearch: '',
    };
  },
  computed: {
    ...mapGetters({
      inputMap: 'parameters/inputMap',
      parameters: 'parameters/parameters',
    }),
    filteredParameters() {
      return this.applyFilterParameter(this.parameters, this.valueToSearch);
    },
    filteredParameterTree() {
      return this.filteredParameters.matches;
    },
    filteredParameterCount() {
      return this.filteredParameters.count;
    },
    firstParameterIndex() {
      return this.filteredParameterCount > 0 ? 1 : 0;
    },
    totalParameterCount() {
      return Object.keys(this.inputMap).length;
    },
    scenario() {
      return this.$nuxt.context.store.getters['scenarios/singleScenario'](
        this.job.scenario.id
      );
    },
    activeJob() {
      return this.$nuxt.context.store.state.ui.activeJob;
    },
  },
  methods: {
    setSearchValue(valueToSearch) {
      this.valueToSearch = valueToSearch;
    },
  },
};
</script>
